Class | Sequel::ADO::Database
In: | lib/sequel/adapters/ado.rb
Parent: | Sequel::Database

### Methods

connect dataset do execute new

### Constants

CommandTimeout | = | opts[:command_timeout] if opts[:command_timeout]
Provider | = | opts[:provider] if opts[:provider]

### Public Class methods

new(opts)

[Source]

        # File lib/sequel/adapters/ado.rb, line 9
     9:       def initialize(opts)
    10:         super
    11:         @opts[:driver] ||= 'SQL Server'
    12:         case @opts[:driver]
    13:         when 'SQL Server'
    14:           Sequel.ts_require 'adapters/ado/mssql'
    15:           extend Sequel::ADO::MSSQL::DatabaseMethods
    16:         end
    17:       end

### Public Instance methods

connect(server)

In addition to the usual database options, the following options have an effect:

:command_timeout : | Sets the time in seconds to wait while attempting to execute a command before cancelling the attempt and generating an error. Specifically, it sets the ADO CommandTimeout property. If this property is not set, the default of 30 seconds is used.
:driver : | The driver to use in the ADO connection string. If not provided, a default of "SQL Server" is used.
:conn_string : | The full ADO connection string. If this is provided, the usual options are ignored.
:provider : | Sets the Provider of this ADO connection (for example, "SQLOLEDB"). If you don‘t specify a provider, the default one used by WIN32OLE has major problems, such as creating a new native database connection for every query, which breaks things such as temporary tables.

Pay special attention to the :provider option, as without specifying a provider, many things will be broken. The SQLNCLI10 provider appears to work well if you are connecting to Microsoft SQL Server, but it is not the default as that would break backwards compatability.

[Source]

        # File lib/sequel/adapters/ado.rb, line 39
    39:       def connect(server)
    40:         opts = server_opts(server)
    41:         s = opts[:conn_string] || "driver=#{opts[:driver]};server=#{opts[:host]};database=#{opts[:database]}#{";uid=#{opts[:user]};pwd=#{opts[:password]}" if opts[:user]}"
    42:         handle = WIN32OLE.new('ADODB.Connection')
    43:         handle.CommandTimeout = opts[:command_timeout] if opts[:command_timeout]
    44:         handle.Provider = opts[:provider] if opts[:provider]
    45:         handle.Open(s)
    46:         handle
    47:       end

dataset(opts = nil)

[Source]

        # File lib/sequel/adapters/ado.rb, line 49
    49:       def dataset(opts = nil)
    50:         ADO::Dataset.new(self, opts)
    51:       end

do(sql, opts={})

Alias for execute

execute(sql, opts={}) {|r| ...}

[Source]

        # File lib/sequel/adapters/ado.rb, line 53
    53:       def execute(sql, opts={})
    54:         synchronize(opts[:server]) do |conn|
    55:           begin
    56:             r = log_yield(sql){conn.Execute(sql)}
    57:             yield(r) if block_given?
    58:           rescue ::WIN32OLERuntimeError => e
    59:             raise_error(e)
    60:           end
    61:         end
    62:         nil
    63:       end

[Validate]